## yade 0.80.1

=== CMakeLists.txt ===
# cmake build file for yade
# the way to build yade
# 1. gather all source files in chunks (using COMBINE_SOURCES) that will be compiled together
#    (otherwise each source file would be compiled separately, which is too slow)
#    Unlike in scons compilations, also python modules are gathered in chunks.
# 2. create yade-all library that is compiled from all the chunks
# 3. Create symlinks pointing to yade-all for all python modules we want to create
#    (this will have to be 
#
#
project(Yade C CXX)
cmake_minimum_required(VERSION 2.8)

include(FindPythonLibs)
include(FindPythonInterp)
include(FindOpenMP)
include(FindOpenGL)
include(FindQt4)
include(FindBoost)
include(FindVTK)
include(FindPkgConfig)
include(FeatureSummary)

find_package(Boost COMPONENTS python thread date_time filesystem iostreams regex serialization)
find_package(Qt4 COMPONENTS QtCore QtGgui QtOpenGL)
find_package(VTK COMPONENTS Common REQUIRED) 

add_definitions(-DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast)

IF (NOT LIB_EIGEN_PATH)
 SET(LIB_EIGEN_PATH "/usr/include/eigen2")
 MESSAGE("Headers of eigen library will be included from  ${LIB_EIGEN_PATH}, if you want to override it use -DLIB_EIGEN_PATH option.")
ENDIF (NOT LIB_EIGEN_PATH)

INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${LIB_EIGEN_PATH})
INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/extra/floating_point_utilities_v3)

find_path(CGAL_INCLUDE_DIR CGAL/Exact_predicates_inexact_constructions_kernel.h REQUIRED)
find_library(CGAL_FOUND CGAL)
if(${CGAL_FOUND})
	add_definitions(-frounding-math)
	INCLUDE_DIRECTORIES(${CGAL_INCLUDE_DIR})
endif()

pkg_search_module(GTS gts)

# ccache distcc clang++: must check compiler and its first 2 "args"
if((CMAKE_CXX_COMPILER MATCHES ".*clang.*") OR (CMAKE_CXX_COMPILER_ARG1 MATCHES ".*clang.*") OR (CMAKE_CXX_COMPILER_ARG2 MATCHES ".*clang.*"))
	add_definitions(-Wno-unused-variable -Wno-mismatched-tags -Wno-constant-logical-operand -Qunused-arguments -Wno-empty-body)
	MESSAGE("Using clang, suppressing some warnings.")
endif()
	

#set(CMAKE_VERBOSE_MAKEFILE 1)

IF (NOT CHUNKSIZE)
 SET(CHUNKSIZE 100)
 MESSAGE("Maximum files to compile in one translation unit ${CHUNKSIZE}, if you want to override it use -DCHUNKSIZE option.")
ENDIF (NOT CHUNKSIZE)


IF (NOT INSTALL_PREFIX)
 SET(CMAKE_INSTALL_PREFIX "/usr/local")
 MESSAGE("Yade will be installed to default path ${CMAKE_INSTALL_PREFIX}, if you want to override it use -DINSTALL_PREFIX option.")
ELSE (NOT INSTALL_PREFIX)
	SET(CMAKE_INSTALL_PREFIX ${INSTALL_PREFIX})
	MESSAGE("Yade will be installed to ${CMAKE_INSTALL_PREFIX}")
ENDIF (NOT CMAKE_INSTALL_PREFIX)


SET(YADE_LIB_PATH ${CMAKE_INSTALL_PREFIX}/lib/yade-${SUFFIX})
SET(YADE_EXEC_PATH ${CMAKE_INSTALL_PREFIX}/bin)
SET(YADE_PY_PATH ${YADE_LIB_PATH}/py)

#"OPENMP" 
FOREACH(FEAT "OPENGL" "VTK" "GTS" "CGAL")
	if("${FEAT}_FOUND")
		add_definitions(-DYADE_${FEAT})
		message("Feature ${FEAT} enabled")
	endif()
ENDFOREACH()
PRINT_ENABLED_FEATURES()
PRINT_DISABLED_FEATURES()

# this is only a temporary hack, headers should be installed in the build-dir directly
# perhaps there is a proper way, have to ask
if(NOT EXISTS "${CMAKE_BINARY_DIR}/yade")
	EXECUTE_PROCESS(COMMAND ln -s ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR}/yade)
endif()
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})


# include several source files (in SRCS) in one or more
# combined files; each combined file holds maximally 
# MAXNUM files.
# BASE gives basename for created files;
# files corresponding to the pattern are deleted
# first, so that there are no relicts from previous runs
# with possibly different MAXNUM
MACRO(COMBINE_SOURCES BASE SRCS MAXNUM)
	LIST(LENGTH SRCS SRCS_LENGTH)
	SET(COMB_COUNTER 0)
	FILE(GLOB EXISTING "${BASE}.*.cpp")
	IF("$EXISTING")
		FILE(REMOVE ${EXISTING})
	ENDIF()
	SET(OUT "${BASE}.${COMB_COUNTER}.cpp")
	FILE(WRITE ${OUT})
	SET(COUNTER 0)
	FOREACH(SRC ${SRCS})
		if(${SRC} MATCHES "^/.*$") # absolute filename
			FILE(APPEND ${OUT} "#include<${SRC}>\n")
		else()
			FILE(APPEND ${OUT} "#include<${CMAKE_SOURCE_DIR}/${SRC}>\n")
		endif()
		MATH(EXPR COUNTER "${COUNTER}+1")
		IF(${COUNTER} EQUAL ${MAXNUM})
			SET(COUNTER 0)
			MATH(EXPR COMB_COUNTER ${COMB_COUNTER}+1)
			SET(OUT "${BASE}.${COMB_COUNTER}.cpp")
			FILE(WRITE ${OUT})
		ENDIF()
	ENDFOREACH()
ENDMACRO()

FILE(GLOB         SRC_CORE "core/*.cpp")
FILE(GLOB_RECURSE SRC_PKG "pkg/*.cpp")
# without lib/, will be added below
SET(SRC_LIB "lib/base/Math.cpp;lib/factory/ClassFactory.cpp;lib/factory/DynLibManager.cpp;lib/multimethods/Indexable.cpp;lib/serialization/Serializable.cpp;lib/pyutil/gil.cpp")
IF(${CGAL_FOUND})
	SET(SRC_LIB "${SRC_LIB};lib/triangulation/KinematicLocalisationAnalyser.cpp;lib/triangulation/Operations.cpp;lib/triangulation/RegularTriangulation.cpp;lib/triangulation/Timer.cpp;lib/triangulation/basicVTKwritter.cpp;lib/triangulation/FlowBoundingSphere.cpp;lib/triangulation/Network.cpp;lib/triangulation/Deformation.cpp;lib/triangulation/Empilement.cpp;lib/triangulation/stdafx.cpp;lib/triangulation/Tenseur3.cpp;lib/triangulation/Tesselation.cpp;lib/triangulation/TriaxialState.cpp")
ENDIF()
IF(${OPENGL_FOUND})
	SET(SRC_LIB "${SRC_LIB};lib/opengl/GLUtils.cpp")
ENDIF()

# the last number is "chunkSize"
COMBINE_SOURCES(${CMAKE_BINARY_DIR}/core "${SRC_CORE}" 1000)
COMBINE_SOURCES(${CMAKE_BINARY_DIR}/pkg "${SRC_PKG}" ${CHUNKSIZE})
COMBINE_SOURCES(${CMAKE_BINARY_DIR}/lib "${SRC_LIB}" ${CHUNKSIZE})
FILE(GLOB SRC_CORE_COMBINED "${CMAKE_BINARY_DIR}/core.*.cpp")
FILE(GLOB SRC_PKG_COMBINED  "${CMAKE_BINARY_DIR}/pkg.*.cpp")
FILE(GLOB SRC_LIB_COMBINED  "${CMAKE_BINARY_DIR}/lib.*.cpp")

#add_library(core SHARED ${SRC_CORE_COMBINED})
#add_library(pkg SHARED ${SRC_PKG_COMBINED})
#add_library(support SHARED ${SRC_LIB_COMBINED})
#target_link_libraries(core support)
#target_link_libraries(pkg core)
SET(SRC_PYMODULES py/WeightedAverage2d.cpp;py/_eudoxos.cpp;py/log.cpp;py/_utils.cpp;py/wrapper/customConverters.cpp)

SET(SRC_PACK ${CMAKE_SOURCE_DIR}/py/pack/_packPredicates.cpp;${CMAKE_SOURCE_DIR}/py/pack/_packObb.cpp;${CMAKE_SOURCE_DIR}/py/pack/_packSpheres.cpp) # ;${CMAKE_SOURCE_DIR}/py/pack/_packSpherePadder.cpp;${CMAKE_SOURCE_DIR}/py/pack/SpherePadder/SpherePadder.cpp;${CMAKE_SOURCE_DIR}/py/pack/SpherePadder/TetraMesh.cpp;${CMAKE_SOURCE_DIR}/py/pack/SpherePadder/CellPartition.cpp
#IF(${CGAL_FOUND})
#	SET(SRC_PACK ${SRC_PACK};${CMAKE_SOURCE_DIR}/py/pack/SpherePadder/SpherePackingTriangulation.cpp)
#ENDIF()

COMBINE_SOURCES(${CMAKE_BINARY_DIR}/pyPack "${SRC_PACK}" 100)
SET(SRC_PACK_COMBINED "${CMAKE_BINARY_DIR}/pyPack.0.cpp")
#add_library(pyPack STATIC ${CMAKE_BINARY_DIR}/pyPack.0.cpp)
#add_library(pyWrapper STATIC py/wrapper/yadeWrapper.cpp)

COMBINE_SOURCES(${CMAKE_BINARY_DIR}/pyModules "${SRC_PYMODULES}" 100)
FILE(GLOB SRC_PYMODULES_COMBINED "${CMAKE_BINARY_DIR}/pyModules.*.cpp")
#add_library(pyModules SHARED ${SRC_PYMODULES_COMBINED})
#target_link_libraries(pyModules pyWrapper pyPack pyEigen _gts)

# will be different for debugging builds!
SET(YADE_LIBDIR lib/yade${YADE_SUFFIX})

SET(SRC_PYGTS "py/3rd-party/pygts-0.3.1/cleanup.c;py/3rd-party/pygts-0.3.1/edge.c;py/3rd-party/pygts-0.3.1/face.c;py/3rd-party/pygts-0.3.1/object.c;py/3rd-party/pygts-0.3.1/point.c;py/3rd-party/pygts-0.3.1/pygts.c;py/3rd-party/pygts-0.3.1/segment.c;py/3rd-party/pygts-0.3.1/surface.c;py/3rd-party/pygts-0.3.1/triangle.c;py/3rd-party/pygts-0.3.1/vertex.c")


SET(YADE_ALL_SRCS ${SRC_CORE_COMBINED};${SRC_PKG_COMBINED};${SRC_LIB_COMBINED};${SRC_PYMODULES_COMBINED};${SRC_PACK_COMBINED};${SRC_PYGTS};py/mathWrap/miniEigen.cpp)

python_add_module(yade-all "${YADE_ALL_SRCS}")

IF(${GTS_FOUND})
	#add_library(_gts STATIC py/3rd-party/pygts-0.3.1/cleanup.c;py/3rd-party/pygts-0.3.1/edge.c;py/3rd-party/pygts-0.3.1/face.c;py/3rd-party/pygts-0.3.1/object.c;py/3rd-party/pygts-0.3.1/point.c;py/3rd-party/pygts-0.3.1/pygts.c;py/3rd-party/pygts-0.3.1/segment.c;py/3rd-party/pygts-0.3.1/surface.c;py/3rd-party/pygts-0.3.1/triangle.c;py/3rd-party/pygts-0.3.1/vertex.c)
	include_directories(${GTS_INCLUDE_DIRS})
	add_definitions(-DPYGTS_HAS_NUMPY)
	# see http://www.mail-archive.com/cmake@cmake.org/msg24812.html
	#set_target_properties(_gts
	#	PROPERTIES COMPILE_FLAGS "-Wno-all"
	#	COMPILE_DEFINES -DPYGTS_HAS_NUMPY )
	FOREACH(_libname ${GTS_LIBRARIES})
		target_link_libraries(yade-all ${_libname})
	ENDFOREACH()
ENDIF()

## add_library(pyEigen STATIC py/mathWrap/miniEigen.cpp)


SET(PY_COMPILED_MODULES mathWrap;gts/_gts;yade/boot;yade/log;yade/wrapper;yade/_customConverters;yade/_eudoxos;yade/_packPredicates;yade/_packSpheres;yade/_packObb;yade/_utils;yade/WeightedAverage2d) # ;yade/_packSpherePadder
IF(${QT4_FOUND})
	SET(PY_COMPILED_MODULES ${PY_COMPILED_MODULES};yade/qt/_GLViewer)
ENDIF()


install(TARGETS yade-all DESTINATION ${YADE_LIB_PATH})

FOREACH(_mod ${PY_COMPILED_MODULES})
	install(CODE "EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E create_symlink ${YADE_LIB_PATH}/libyade-all.so ${YADE_PY_PATH}/${_mod}.so)")
ENDFOREACH()


# install our python scripts, keeping the hierarchy under py/
install(DIRECTORY py/ DESTINATION ${YADE_PY_PATH}
	FILES_MATCHING PATTERN "*.py"
	PATTERN "3rd-party" EXCLUDE
)

# install 3rd party python files
install(FILES py/3rd-party/pygts-0.3.1/__init__.py DESTINATION ${YADE_LIB_PATH}/gts)
install(FILES py/3rd-party/pygts-0.3.1/pygts.py DESTINATION ${YADE_LIB_PATH}/gts)
install(FILES py/3rd-party/mtTkinter-0.3/mtTkinter.py DESTINATION ${YADE_LIB_PATH})

# install the files that need to be pre-processed (FIXME: this will need to define all variables, and call them the same as they are in scons -- for compatibility)
configure_file(core/main/yade-batch.in ${YADE_EXEC_PATH}/yade-batch-${SUFFIX})
configure_file(core/main/main.py.in ${YADE_EXEC_PATH}/yade-${SUFFIX})
configure_file(py/config.py.in ${YADE_PY_PATH}/yade/config.py)

=== SConstruct ===
#!/usr/bin/scon
# coding: UTF-8
# vim:syntax=python:

#
# This is the master build file for scons (http://www.scons.org). It is experimental, though it build very well for me. Prequisities for running are having scons installed (debian & family: package scons)
#
# Type "scons -h" for yade-specific options and "scons -H" for scons' options. Note that yade options will be remembered (saved in scons.config) so that you need to specify them only for the first time. Like this, for example:
#
#	scons -j2 brief=1 debug=0 optimize=1 profile=1 exclude=extra,lattice,snow
#
# Next time, you can simply run "scons" or "scons -j4" (for 4-parallel builds) to rebuild targets that need it. IF YOU NEED TO READ CODE IN THIS FILE, SOMETHING IS BROKEN AND YOU SHOULD REALLY TELL ME.
#
# Scons will do preparatory steps (generating SConscript files from .pro files, creating local include directory and symlinking all headers from there, ...), compile files and install them.
#
# To clean the build, run `scons -c'. Please note that it will also _uninstall_ yade from $PREFIX!
#
# TODO:
#  1. [REMOVED] [DONE] retrieve target list and append install targets dynamically;
#  2. [DONE] configuration and option handling.
#  3. Have build.log with commands and all output...
#
# And as usually, clean up the code, get rid of workarounds and hacks etc.
import os,os.path,string,re,sys,shutil
import SCons
# SCons version numbers are needed a few times
# rewritten for python2.4
ver=[str(x) for x in SCons.__version__.split('.')]
for i in range(0,len(ver)):
	def any2num(x):
		if x in ('0123456789'): return x
		else: return '0'
	ver[i]="".join([any2num(x) for x in ver[i]])
	if len(ver[i])>2: ver[i]=ver[i][0:2]+"."+ver[i][2:]
sconsVersion=10000*float(ver[0])
if len(ver)>1: sconsVersion+=100*float(ver[1])
if len(ver)>2: sconsVersion+=float(ver[2])
# print sconsVersion
#

##########################################################################################
############# OPTIONS ####################################################################
##########################################################################################

### hardy compatibility (may be removed at some later point probably)
### used only when building debian package, since at that point auto download of newer scons is disabled
if 'Variables' not in dir():
	Variables=Options
	BoolVariable,ListVariable,EnumVariable=BoolOption,ListOption,EnumOption

env=Environment(tools=['default','scanreplace'],toolpath=['scripts'])
profileFile='scons.current-profile'
env['sourceRoot']=os.getcwd()

profOpts=Variables(profileFile)
profOpts.Add(('profile','Config profile to use (predefined: default or ""); append ! to use it but not save for next build (in scons.current-profile)','default'))
profOpts.Update(env)
# multiple profiles - run them all at the same time
# take care not to save current profile for those parallel builds
if env['profile']=='': env['profile']='default'
# save the profile only if the last char is not !
saveProfile=True
if env['profile'][-1]=='!': env['profile'],noSaveProfile=env['profile'][:-1],False
if saveProfile: profOpts.Save(profileFile,env)

if env['profile']=='': env['profile']='default'
optsFile='scons.profile-'+env['profile']
profile=env['profile']
print '@@@ Using profile',profile,'('+optsFile+') @@@'

opts=Variables(optsFile)
## compatibility hack again
if 'AddVariables' not in dir(opts): opts.AddVariables=opts.AddOptions

def colonSplit(x): return x.split(':')

#
# The convention now is, that
#  1. CAPITALIZED options are
#   (a) notorious shell variables (they correspons most the time to SCons environment options of the same name - like CPPPATH)
#   (b) c preprocessor macros available to the program source (like PREFIX and SUFFIX)
#  2. lowercase options influence the building process, compiler options and the like.
#


opts.AddVariables(
	### OLD: use PathOption with PathOption.PathIsDirCreate, but that doesn't exist in 0.96.1!
	('PREFIX','Install path prefix','/usr/local'),
	('runtimePREFIX','Runtime path prefix; DO NOT USE, inteded for packaging only.',None),
	('variant','Build variant, will be suffixed to all files, along with version.','' if profile=='default' else '-'+profile,None,lambda x:x),
	BoolVariable('debug', 'Enable debugging information',0),
	BoolVariable('gprof','Enable profiling information for gprof',0),
	('optimize','Turn on optimizations (-1, 0 or 1); with negative value (-1) optimization is based on debugging: not optimize with debugging (debug=True <=> optimize=False) and vice versa. With positive values optimization is performed (case of 1) or not (0) independent of debugging',-1,None,int),
	EnumVariable('PGO','Whether to "gen"erate or "use" Profile-Guided Optimization','',['','gen','use'],{'no':'','0':'','false':''},1),
	ListVariable('features','Optional features that are turned on','opengl,gts,openmp,vtk,qt4',names=['opengl','log4cxx','cgal','openmp','gts','vtk','gl2ps','qt4']),
	('jobs','Number of jobs to run at the same time (same as -j, but saved)',2,None,int),
	#('extraModules', 'Extra directories with their own SConscript files (must be in-tree) (whitespace separated)',None,None,Split),
	('buildPrefix','Where to create build-[version][variant] directory for intermediary files','..'),
	('hotPlugins','Files (without the .cpp extension) that will be compiled separately even in the monolithic build (use for those that you modify frequently); comma-separated.',''),
	('chunkSize','Maximum files to compile in one translation unit when building plugins. (unlimited if <= 0, per-file linkage is used if 1)',7,None,int),
	('version','Yade version (if not specified, guess will be attempted)',None),
	('realVersion','Revision (usually bzr revision); guessed automatically unless specified',None),
	('CPPPATH', 'Additional paths for the C preprocessor (colon-separated)','/usr/include/vtk-5.0:/usr/include/vtk-5.2:/usr/include/vtk-5.4:/usr/include/vtk-5.6:/usr/include/vtk-5.8:/usr/include/vtk'), # hardy has vtk-5.0
	('LIBPATH','Additional paths for the linker (colon-separated)',None),
	('libstdcxx','Specify libstdc++ location by hand (opened dynamically at startup), usually not needed',None),
	('QT4CXX','Specify a different compiler for files including qt4; this is necessary for older qt version (<=4.7) which don\'t compile with clang',None),
	('QT4DIR','Directory where Qt4 is installed','/usr/share/qt4'),
	('PATH','Path (not imported automatically from the shell) (colon-separated)',None),
	('CXX','The c++ compiler','g++'),
	('CXXFLAGS','Additional compiler flags for compilation (like -march=core2).',None,None,Split),
	('march','Architecture to use with -march=... when optimizing','native',None,None),
	('execCheck','Name of the main script that should be installed; if the current one differs, an error is raised (do not use directly, only intended for --rebuild',None),
	('defThreads','No longer used, specify -j each time yade is run (defaults to 1 now)',-1),
	#('SHLINK','Linker for shared objects','g++'),
	('SHCCFLAGS','Additional compiler flags for linking (for plugins).',None,None,Split),
	BoolVariable('QUAD_PRECISION','typedef Real as long double (=quad)',0),
	BoolVariable('brief',"Don't show commands being run, only what files are being compiled/linked/installed",True),
	BoolVariable('eigen2',"Force to use eigen2, if even eigen3 persists in the system.",False),
)
opts.Update(env)

if str(env['features'])=='all':
	print 'ERROR: using "features=all" is illegal, since it breaks feature detection at runtime (SCons limitation). Write out all features separated by commas instead. Sorry.'
	Exit(1)

#Clean eigen directories
if env.has_key('CPPPATH'):
	cpppathes=colonSplit(env['CPPPATH'])
	env['CPPPATH'] = ''
	z=0
	for i in cpppathes:
		if (i[:-1] <> '/usr/include/eigen'):
			if (z==0):
				env.Append(CPPPATH=i)
			else:
				env.Append(CPPPATH=":"+i)
			z+=1

#Check, is there eigen3 directory, if not - use eigen2
if os.path.exists('/usr/include/eigen3') and not (env['eigen2']):
	print "Eigen 3 math library will be used"
	env.Append(CPPPATH=":/usr/include/eigen3")
elif os.path.exists('/usr/include/eigen2'):
	print "Eigen 2 math library will be used"
	env.Append(CPPPATH=":/usr/include/eigen2")
else:
	raise RuntimeError("None of mathematical libraries (eigen2 or eigen3) can be used.")

if saveProfile: opts.Save(optsFile,env)
# fix expansion in python substitution by assigning the right value if not specified
if not env.has_key('runtimePREFIX') or not env['runtimePREFIX']: env['runtimePREFIX']=env['PREFIX']
# set optimization based on debug, if required
if env['optimize']<0: env['optimize']=not env['debug']

# handle colon-separated lists:
for k in ('CPPPATH','LIBPATH','QTDIR','PATH'):
	if env.has_key(k):
		env[k]=colonSplit(env[k])

# do not propagate PATH from outside, to ensure identical builds on different machines
#env.Append(ENV={'PATH':['/usr/local/bin','/bin','/usr/bin']})
# ccache needs $HOME to be set, also CCACHE_PREFIX if used; colorgcc needs $TERM; distcc wants DISTCC_HOSTS
# fakeroot needs FAKEROOTKEY and LD_PRELOAD
propagatedEnvVars=['HOME','TERM','DISTCC_HOSTS','LD_PRELOAD','FAKEROOTKEY','LD_LIBRARY_PATH','CCACHE_PREFIX']
for v in propagatedEnvVars:
	if os.environ.has_key(v): env.Append(ENV={v:os.environ[v]})
if env.has_key('PATH'): env.Append(ENV={'PATH':env['PATH']})

# get number of jobs from DEB_BUILD_OPTIONS if defined
# see http://www.de.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
if os.environ.has_key('DEB_BUILD_OPTIONS'):
	for opt in os.environ['DEB_BUILD_OPTIONS'].split():
		if opt.startswith('parallel='):
			j=opt.split('=')[1].split(',')[0] # there was a case of 5, in hardy...
			print "Setting number of jobs (using DEB_BUILD_OPTIONS) to `%s'"%j
			env['jobs']=int(j)



if sconsVersion>9700: opts.FormatOptionHelpText=lambda env,opt,help,default,actual,alias: "%10s: %5s [%s] (%s)\n"%(opt,actual,default,help)
else: opts.FormatOptionHelpText=lambda env,opt,help,default,actual: "%10s: %5s [%s] (%s)\n"%(opt,actual,default,help)
Help(opts.GenerateHelpText(env))

###########################################
################# BUILD DIRECTORY #########
###########################################
import yadeSCons
## ALL generated stuff should go here - therefore we must determine it very early!!
if not env.has_key('realVersion') or not env['realVersion']: env['realVersion']=yadeSCons.getRealVersion() or 'unknown' # unknown if nothing returned
if not env.has_key('version'): env['version']=env['realVersion']

env['SUFFIX']=('-'+env['version'] if len(env['version'])>0 else '')+env['variant']
env['SUFFIX_DBG']=env['SUFFIX']+('' if not env['debug'] else '/dbg')
env['LIBDIR']='$PREFIX/lib/yade$SUFFIX_DBG'
print "Yade version is `%s' (%s), installed files will be suffixed with `%s'."%(env['version'],env['realVersion'],env['SUFFIX'])
buildDir=os.path.abspath(env.subst('$buildPrefix/build$SUFFIX_DBG'))
print "All intermediary files will be in `%s'."%env.subst(buildDir)
env['buildDir']=buildDir
# these MUST be first so that builddir's headers are read before any locally installed ones
buildInc='$buildDir/include'
env.Append(CPPPATH=[buildInc])

env.SConsignFile(buildDir+'/scons-signatures')

##########################################################################################
############# SHORTCUT TARGETS ###########################################################
##########################################################################################

if len(sys.argv)>1 and ('clean' in sys.argv) or ('tags' in sys.argv) or ('doc' in sys.argv):
	if 'clean' in sys.argv:
		if os.path.exists(buildDir):
			print "Cleaning: %s."%buildDir; shutil.rmtree(buildDir)
		else: print "Nothing to clean: %s."%buildDir
		sys.argv.remove('clean')
	if 'tags' in sys.argv:

=== debian/changelog ===
yade (0.80.1-2) unstable; urgency=low

  * [9ddf3c4] Handle ipython 0.13. (Closes: #680285)

 -- Anton Gladky <gladky.anton@gmail.com>  Wed, 04 Jul 2012 21:41:22 +0200

yade (0.80.1-1) unstable; urgency=low

  * [64a8de3] Imported Upstream version 0.80.1

 -- Anton Gladky <gladky.anton@gmail.com>  Tue, 29 May 2012 23:20:12 +0200

yade (0.80.0-3) unstable; urgency=low

  * [fd11426] Add minimal version for dpkg-dev (>= 1.16.2).
  * [2259a3f] Fix FTBFS against gcc-4.7. (Closes: #672126)

 -- Anton Gladky <gladky.anton@gmail.com>  Wed, 09 May 2012 20:34:48 +0200

yade (0.80.0-2) unstable; urgency=low

  * [17ac3c8] Recover fix_FTBFS_on_KFreeBSD.patch.

 -- Anton Gladky <gladky.anton@gmail.com>  Sat, 05 May 2012 06:57:35 +0200

yade (0.80.0-1) unstable; urgency=low

  * [714d23e] Enable cgal-feature.
  * [f5fe5b4] Remove patches, applied by upstream.
  * [2d168c8] Use compat-level 8.
  * [0b404ca] Imported Upstream version 0.80.0
  * [19b9ce5] Re-enable PDF-generation. (Closes: #651220)

 -- Anton Gladky <gladky.anton@gmail.com>  Wed, 02 May 2012 23:22:19 +0200

=== debian/control ===
Source: yade
Section: science
Priority: extra
Homepage: https://launchpad.net/yade
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladky.anton@gmail.com>
DM-Upload-Allowed: yes
Vcs-Git: git://git.debian.org/git/debian-science/packages/yade.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/yade.git
Build-Depends: debhelper (>= 8), scons, binutils-gold [amd64 i386], 
 freeglut3-dev, libboost-dev (>=1.35), libboost-date-time-dev (>=1.35), 
 libboost-filesystem-dev (>=1.35), libboost-thread-dev (>=1.35), 
 libboost-regex-dev (>=1.35), libboost-python-dev (>=1.35),
 libboost-iostreams-dev (>=1.35), libboost-program-options-dev, 
 python-support, libboost-serialization-dev, libloki-dev, 
 docbook-to-man, ipython, libgts-dev, python-numpy, g++(>>4.0), libvtk5-dev, 
 libgl1-mesa-dev, gdb, python-matplotlib, python-tk, libeigen3-dev, 
 libqglviewer-qt4-dev, python-xlib, python-qt4, pyqt4-dev-tools, python-imaging,
 libcgal-dev, dpkg-dev (>= 1.16.2)
Build-Depends-Indep: texlive-latex-recommended, texlive-latex-extra, lmodern, 
 texlive-pictures, texlive-xetex, libjs-jquery, python-sphinx (>=1.0.6),
 python-bibtex, graphviz, dvipng, libjs-underscore, tipa
Standards-Version: 3.9.3

Package: yade
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
 python (>= 2.7), python (<<2.8), 
 python-numpy, ipython, python-matplotlib, python-tk, python-qt4, 
 python-xlib, gnuplot, python-imaging, libjs-jquery, libjs-underscore,
 gtk2-engines-pixbuf
Recommends: mencoder
Description: Platform for discrete element modeling
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models, 
 focused on Discrete Element Method. 
 The computation parts are written in c++ using flexible object model, 
 allowing independent implementation of new algorithms and interfaces. 
 Python is used for rapid and concise scene construction, 
 simulation control, postprocessing and debugging.
 .
 This package contains speed-optimized build of yade.

Package: yade-doc
Architecture: all
Section: doc
Recommends: yade
Depends: ${misc:Depends}, libjs-jquery
Description: Platform for discrete element modeling. Documentation
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models, 
 focused on Discrete Element Method. 
 The computation parts are written in c++ using flexible object model, 
 allowing independent implementation of new algorithms and interfaces. 
 Python is used for rapid and concise scene construction, 
 simulation control, postprocessing and debugging.
 .
 This package contains examples, test scripts and documentation.

=== debian/rules ===
#!/usr/bin/make -f

tmpDirMatplotLib = $(CURDIR)/debian/matplotlib
tmpInstall = $(CURDIR)/debian/inst
CXXFLAGS := -Wall $(shell dpkg-buildflags --get CXXFLAGS)

%:
	dh $@

override_dh_auto_clean:
	rm -rf debian/build
	rm -rf doc/sphinx/_build
	rm -rf tags
	rm -f scons.*
	rm -f *.1
	rm -rf $(tmpDirMatplotLib)
	rm -rf $(tmpInstall)
	find . -name '*.pyc' -print0 | xargs -0 rm -f
	dh_clean 

override_dh_auto_configure:
	mkdir -p $(tmpDirMatplotLib)
	mkdir -p $(tmpInstall)

override_dh_auto_build-arch:
	# remove the profile, if existing, to have clean config
	rm -f scons.*
	#Output an information about available memory and CPU
	-cat /proc/meminfo
	-cat /proc/cpuinfo
	#optimized build
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib)$ ; NO_SCONS_GET_RECENT= scons profile=deb buildPrefix=debian runtimePREFIX=/usr version='' brief=0 chunkSize=2 features=vtk,gts,opengl,qt4,openmp,cgal PREFIX=$(tmpInstall) variant='' CXXFLAGS='$(CXXFLAGS)' optimize=1 -j1 march= debug=0 
	# generate manpages
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; YADE_PREFIX=$(tmpInstall) $(tmpInstall)/bin/yade --generate-manpage yade.1
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; YADE_PREFIX=$(tmpInstall) $(tmpInstall)/bin/yade-batch --generate-manpage yade-batch.1

override_dh_auto_test:
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; YADE_PREFIX=$(tmpInstall) $(tmpInstall)/bin/yade --test
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; YADE_PREFIX=$(tmpInstall) $(tmpInstall)/bin/yade --check
	#Delete all pyc files
	find . -name '*.pyc' -print0 | xargs -0 rm -f

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_installman:
	dh_installman -p yade yade.1 yade-batch.1

override_dh_compress:
	dh_compress --all -X.py -X.stl -X.gts -X.geo -X.mesh -X.msh -X.pdf -X.png -X.svg -X.txt -X.js -X.inv

override_dh_auto_build-indep: 
	#Generate docs
	export MPLCONFIGDIR=$(tmpDirMatplotLib) HOME=$(tmpDirMatplotLib) ; cd doc/sphinx; PYTHONPATH=. YADE_PREFIX=$(tmpInstall) $(tmpInstall)/bin/yade yadeSphinx.py; cd _build/latex; xelatex Yade.tex; xelatex Yade.tex; xelatex Yade.tex;

=== debian/watch ===
version=3
http://launchpad.net/yade/+download http://launchpad.net/yade/trunk/.*/yade-(.+).tar.bz2
